/*****************************************************************************

  Zope Public License (ZPL) Version 1.0
  -------------------------------------

  Copyright (c) Digital Creations.  All rights reserved.

  This license has been certified as Open Source(tm).

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are
  met:

  1. Redistributions in source code must retain the above copyright
     notice, this list of conditions, and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions, and the following disclaimer in
     the documentation and/or other materials provided with the
     distribution.

  3. Digital Creations requests that attribution be given to Zope
     in any manner possible. Zope includes a "Powered by Zope"
     button that is installed by default. While it is not a license
     violation to remove this button, it is requested that the
     attribution remain. A significant investment has been put
     into Zope, and this effort will continue if the Zope community
     continues to grow. This is one way to assure that growth.

  4. All advertising materials and documentation mentioning
     features derived from or use of this software must display
     the following acknowledgement:

       "This product includes software developed by Digital Creations
       for use in the Z Object Publishing Environment
       (http://www.zope.org/)."

     In the event that the product being advertised includes an
     intact Zope distribution (with copyright and license included)
     then this clause is waived.

  5. Names associated with Zope or Digital Creations must not be used to
     endorse or promote products derived from this software without
     prior written permission from Digital Creations.

  6. Modified redistributions of any form whatsoever must retain
     the following acknowledgment:

       "This product includes software developed by Digital Creations
       for use in the Z Object Publishing Environment
       (http://www.zope.org/)."

     Intact (re-)distributions of any official Zope release do not
     require an external acknowledgement.

  7. Modifications are encouraged but must be packaged separately as
     patches to official Zope releases.  Distributions that do not
     clearly separate the patches from the original work must be clearly
     labeled as unofficial distributions.  Modifications which do not
     carry the name Zope may be packaged in any form, as long as they
     conform to all of the clauses above.


  Disclaimer

    THIS SOFTWARE IS PROVIDED BY DIGITAL CREATIONS ``AS IS'' AND ANY
    EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL DIGITAL CREATIONS OR ITS
    CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
    LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
    USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
    ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
    OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
    OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.


  This software consists of contributions made by Digital Creations and
  many individuals on behalf of Digital Creations.  Specific
  attributions are listed in the accompanying credits file.

 ****************************************************************************/

/*
 *  zopestudio-clahandler.js, command line argument handler for -zopestudio
 *  Version: $Revision: 1.2 $
 *
 *  $Id: zopestudio-clahandler.js,v 1.2 2000/06/21 13:12:38 mj Exp $
 */

/*
 * Constants
 */
const ZOPESTUDIOSERVICE_PROGID = 
    'component://netscape/commandlinehandler/general-startup-zopestudio';
const ZOPESTUDIOSERVICE_CID = 
    Components.ID('{847a36f4-325f-41b5-afd1-9f3849e258dc}');

/*
 * Classes
 */

/* zopeStudioHandler class constructor */
function zopeStudioHandler() {}

/* zopeStudioHandler class def */
zopeStudioHandler.prototype = {
    commandLineArgument: '-zopestudio',
    prefNameForStartup: 'general.startup.zopestudio',
    chromeUrlForTask: 'chrome://zopestudio/content/',
    helpText: 'Start with Zope Studio',
    handlesArgs: true,
    defaultArgs: '',
    openWindowWithArgs: true
};

/*
 * Objects
 */

/* zopeStudioHandler Module (for XPCOM registration) */
var zopeStudioHandlerModule = {
    registerSelf: function(compMgr, fileSpec, location, type) {
        compMgr.registerComponentWithType(ZOPESTUDIOSERVICE_CID, 
            'ZopeStudio command line argument handler component',
            ZOPESTUDIOSERVICE_PROGID, fileSpec, location, true, true, type);
        var catman = Components.classes["mozilla.categorymanager.1"]
            .getService(Components.interfaces.nsICategoryManager);
        catman.addCategoryEntry("command-line-argument-handlers",
            "zopestudio", ZOPESTUDIOSERVICE_PROGID, true, true);
    },

    unregisterSelf: function(compMgr, fileSpec, location) {
        compMgr.unregisterComponentSpec(ZOPESTUDIOSERVICE_CID, fileSpec);
        var catman = Components.classes["mozilla.categorymanager.1"]
            .getService(Components.interfaces.nsICategoryManager);
        catman.deleteCategoryEntry("command-line-argument-handlers",
            "zopestudio", true);
    },

    getClassObject: function(compMgr, cid, iid) {
        if (!cid.equals(ZOPESTUDIOSERVICE_CID))
            throw Components.results.NS_ERROR_NO_INTERFACE;

        if (!iid.equals(Components.interfaces.nsIFactory))
            throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

        return zopeStudioHandlerFactory;
    },

    canUnload: function(compMgr) { return true; }
};

/* zopeStudioHandler Class Factory */
var zopeStudioHandlerFactory = {
    CreateInstance: function(outer, iid) {
        if (outer != null)
            throw Components.results.NS_ERROR_NO_AGGREGATION;
    
        if (!iid.equals(Components.interfaces.nsICmdLineHandler) &&
            !iid.equals(Components.interfaces.nsISupports))
            throw Components.results.NS_ERROR_INVALID_ARG;

        return new zopeStudioHandler();
    }
}

/*
 * Functions
 */

/* module initialisation */
function NSGetModule(comMgr, fileSpec) { return zopeStudioHandlerModule; }

// vim:sw=4:sr:sta:et:sts:
